searchNodes=[{"ref":"Accessor.html","title":"Accessor","type":"module","doc":"Accessor is an Elixir data structure manipulator wrapper"},{"ref":"Accessor.html#deep_get/3","title":"Accessor.deep_get/3","type":"function","doc":"Get a value from a very deep nested map or list iex&gt; Accessor.deep_get(%{bio: %{name: %{first: &quot;irfan&quot;, last: &quot;hanif&quot;}, age: 22}, position: &quot;software engineer&quot;}, [:bio, :name, :last]) &quot;hanif&quot; iex&gt; Accessor.deep_get(%{bio: %{name: %{first: &quot;irfan&quot;, last: &quot;hanif&quot;}, age: 22}, position: &quot;software engineer&quot;}, [:bio, :name, :middle], &quot;power ranger&quot;) &quot;power ranger&quot;"},{"ref":"Accessor.html#deep_put/3","title":"Accessor.deep_put/3","type":"function","doc":"Update a value in a very deep nested map or list iex&gt; Accessor.deep_put(%{a: %{&quot;b&quot; =&gt; %{c: 42}}}, [:a, &quot;b&quot;, :c], 177) %{a: %{&quot;b&quot; =&gt; %{c: 177}}} iex&gt; Accessor.deep_put(%{a: %{&quot;b&quot; =&gt; %{c: [42, 43, 44]}}}, [:a, &quot;b&quot;, :c, 1], 177) %{a: %{&quot;b&quot; =&gt; %{c: [42, 177, 44]}}}"},{"ref":"Accessor.html#validation/2","title":"Accessor.validation/2","type":"function","doc":"Map or list value validation. The function is very useful to check a value under a very deep and nested map or list. Evaluate these following functions: # This is the spec that will be used as reference to validate data within a map or list def spec do %{ [:bio, &quot;name&quot;, &quot;first&quot;] =&gt; [:is_it_string], [:bio, :age] =&gt; [:is_it_integer], [:position, 0] =&gt; [&amp;is_it_software_engineer/2] } end # This is a custom validator function def is_it_software_engineer(keys, value) do if value == &quot;software engineer&quot; do :ok else {:error, &quot;\#{Enum.join(keys, &quot;.&quot;)} is not a software engineer&quot;} end end These are the results when you call the function: iex&gt; data = ...&gt; %{ ...&gt; bio: %{ ...&gt; &quot;name&quot; =&gt; %{&quot;first&quot; =&gt; &quot;irfan&quot;, &quot;last&quot; =&gt; &quot;hanif&quot;}, age: 22 ...&gt; }, ...&gt; position: [&quot;software engineer&quot;, &quot;junior architect&quot;] ...&gt; } iex&gt; Accessor.validation(data, spec) :ok iex&gt; data = ...&gt; %{ ...&gt; bio: %{ ...&gt; &quot;name&quot; =&gt; %{&quot;first&quot; =&gt; 112548, &quot;last&quot; =&gt; &quot;hanif&quot;}, age: 22 ...&gt; }, ...&gt; position: [&quot;software developer&quot;, &quot;junior architect&quot;] ...&gt; } iex&gt; Accessor.validation(data, spec) {:error, [&quot;bio.name.first is not a string&quot;, &quot;position.0 is not a software engineer&quot;]} This is a list of built-in validator function which you can use directly: :is_it_string to check whether a value is in the form of string :is_it_integer to check whether a value is in the form of integer :is_it_boolean to check whether a value is in the form of boolean As you can see, it is possible for you to use your own custom validator. If you choose to make your own validator, the function must be capable of receiving two arguments keys and value and two returns possibilities: :ok or {:error, error_message}. At example above, is_it_software_engineer/2 is a custom function validator."}]